<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Method;

use TecDiet\Services\ControlFeedingsService;

class ControlFeedingsController extends \Zeedhi\Framework\Controller\Simple {

    protected $controlFeedingsService;

    public function __construct(ControlFeedingsService $controlFeedingsService) {
        $this->controlFeedingsService = $controlFeedingsService;
    }

    public function save(Request\DataSet $request, Response $response) {
        $controlFeedings = $request->getDataSet()->getRows();
        if($controlFeedings) {
            try {
                $dataSet = $this->controlFeedingsService->save($controlFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };

        }

    }
    
     public function delete(Request\DataSet $request, Response $response){
        $controlFeedings = $request->getDataSet()->getRows();
        if($controlFeedings){
            try{
                $dataSet = $this->controlFeedingsService->delete($controlFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            }catch(\Exception $e){
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
        }
    }

}