function SideNavController($element, $scope, ScreenService, $rootScope, eventAggregator) {


    var transformPropertyName;// = ;
    if(typeof document.body.style.webkitTransform === 'string'){
        transformPropertyName = 'webkitTransform';
    } else if(typeof document.body.style.transform === 'string'){
        transformPropertyName = 'transform';
    } else {
        console.error('TRANSFORM IS NOT SUPPORTED BY THIS BROWSER. \n The sidenav is not supported as well');
    }

    eventAggregator.subscribe('onContainerOpen', function() {
        setupCurrentSelectedOption();
    });

    var setupCurrentSelectedOption = function() {
        /*if this event was still not handled */
        if (!menu.newSelectedOptionWasReStyledProperly) {
            /*if any option was selected before, disable it*/
            if (menu.currentSelectedOption) {
                menu.currentSelectedOption.classList.remove('selected');
                menu.currentSelectedOption.children[0].classList.remove('selected');
                menu.currentSelectedOption.children[1].classList.remove('selected');
            }
            /* find the new option to reStyle searching by the option.name*/
            for (var i = itemListContainer.children.length; i--;) {
                if (itemListContainer.children[i].menuName === $rootScope.templateManager.container.name) {

                    menu.currentSelectedOption = itemListContainer.children[i];
                    menu.currentSelectedOption.classList.add('selected');
                    menu.currentSelectedOption.children[0].classList.add('selected');
                    menu.currentSelectedOption.children[1].classList.add('selected');
                    return;
                }
            }
        }
        /* always specify that the next handler call should reStyle the menu */
        menu.newSelectedOptionWasReStyledProperly = false;
    };

    var htmlContainer = $element.get()[0];
    var self = this;
    menu = htmlContainer.querySelector('.rui-sidenav-menu-container');
    overlay = htmlContainer.querySelector('.rui-sidenav-overlay');
    itemListContainer = htmlContainer.querySelector('.rui-sidenav-itens-list');

    menuContainer = document.querySelector('.something-else');

    /* gain controll over the default toggleMenuButton*/
    var hijackZhSideMenu = function() {
        var toggleMenuButton = document.querySelector("*[zh-click='toggleSideMenu()']");
        if (toggleMenuButton) {
            toggleMenuButton.removeAttribute('zh-click');
            toggleMenuButton.onclick = openRuiSideMenu;
            return true;
        }
        else
            return false;
    };

    $scope.clearListItens = () => {
        while(itemListContainer.lastChild){
            itemListContainer.removeChild(itemListContainer.lastChild);
        }
    };

    $scope.init = function() {
        var rootMenu = $scope.templateManager.project.groupMenu;
        $scope.clearListItens();
        for (var i = 0; i < rootMenu.length; i++)
            renderMenuItens($scope.templateManager.project.groupMenu[i]);
    };
    
    eventAggregator.subscribe('onChangeLanguage', $scope.init);

    var addClickListener = function( /*menuItem : object*/ item, /*HTMLElement*/ htmlElement) {
        if (Util.isFunction(item.click)) {
            htmlElement.addEventListener('click', function(e) {
                menu.preventInteraction();
                $scope.$eval(item.click);
            });
        }
        else if (item.windowName && !item.disabled) {
            htmlElement.addEventListener('click', function(e) {
                menu.preventInteraction();
                ScreenService.openWindow(item.windowName);
                selectMenuOption(e.currentTarget);
                menu.closeMenu(false);
            });
        }
    };

    var selectMenuOption = function( /*HTMLElement*/ newMenuOption) {
        menu.currentSelectedOption.classList.remove('selected');
        menu.currentSelectedOption.children[0].classList.remove('selected');
        menu.currentSelectedOption.children[1].classList.remove('selected');

        newMenuOption.classList.add('selected');
        newMenuOption.children[0].classList.add('selected');
        newMenuOption.children[1].classList.add('selected');

        menu.currentSelectedOption = newMenuOption;
        menu.newSelectedOptionWasReStyledProperly = true;
    };

    menu.previousX = null;
    menu.previousTime = null;

    var openingTouchHandler = function(e) {
        if (window.isInScrollMode) {
            return;
        }
        var absoluteDeltaY = Math.abs(e.targetTouches[0].clientY - menu.previousY);
        if (absoluteDeltaY > 100 &&
            menu.currentTranslation < -135 
        ) {
            window.isInScrollMode = true;
            menu.classList.remove('rui-sidenav-transition-mode');
            menu.doTranslate(-280);
            return;
        }
        if (this.firstX < this.openingLimit && $scope.templateManager.container.showMenu) {
            var newTranslationValue = e.touches[0].clientX -
                applicationContentSurface.firstX -
                280;
            menu.isOpening = true;
            if (newTranslationValue < 0) {
                menu.classList.remove('rui-sidenav-transition-mode');
                menu.doTranslate(newTranslationValue);
            }
            else {
                $rootScope.menuOpen = true;
            }
        }
    };

    var openingTouchStartHandler = function(e) {
        applicationContentSurface.firstX = e.touches[0].clientX;
        menu.previousY = e.targetTouches[0].clientY;
        applicationContentSurface.firstTime = e.timeStamp;
        window.isInScrollMode = false; // bugFix #M49
    };

    var openingTouchEndHandler = function(e) {
        if (menu.isOpening) {
            applicationContentSurface.firstX = 0;
            applicationContentSurface.lastX = 0;
            applicationContentSurface.acumulatedX = 0;
            if (menu.currentTranslation > -135 ||
                (menu.currentTranslation - applicationContentSurface.firstX > -250 &&
                    e.timeStamp - applicationContentSurface.firstTime <= 300)
            ) {
                $rootScope.menuOpen = true;
            }
            else {
                $rootScope.menuOpen = false;
            }
            menu.isOpening = false;
            window.isInScrollMode = false;
        }
    };

    var initAppContentSurface = function() {
        applicationContentSurface = document.querySelector('div.container');
        if (applicationContentSurface === null) {
            return;
        }
        else {

            applicationContentSurface.addEventListener('touchend', openingTouchEndHandler);
            applicationContentSurface.addEventListener('touchmove', openingTouchHandler, false);
            applicationContentSurface.addEventListener('touchstart', openingTouchStartHandler);

            applicationContentSurface.firstX = 51;
            applicationContentSurface.lastX = 0;
            applicationContentSurface.acumulatedX = 0;
            menu.previousY = 0;
            applicationContentSurface.openingLimit = 30;
            applicationContentSurface.lastMenuOpeningTime = 0;
            clearInterval($scope.setIntervalID);
        }
    };

    $scope.initAppContentSurface = function() {
        $scope.setIntervalIterationCount = 0;
        $scope.setIntervalIterationLimit = 50;
        $scope.setIntervalID = setInterval(function() {
            if ($scope.setIntervalIterationCount > $scope.setIntervalIterationLimit)
                clearInterval($scope.setIntervalID);
            $scope.setIntervalIterationCount++;
            initAppContentSurface.call(self);
        }, 100);
    };

    menu.translatePlus = function(value) {
        menu.currentTranslation = Math.round(value + menu.currentTranslation);
        menu.style[transformPropertyName] = 'translate3d(' + menu.currentTranslation + 'px,0,0)';

    };

    menu.doTranslate = function(value) {
        menu.currentTranslation = Math.round(value);
        requestAnimationFrame(function() {
            menu.style[transformPropertyName] = 'translate3d(' + value + 'px,0,0)';
        });
    };

    var touchHandler = function(event) {
        if (window.isInScrollMode) {
            return;
        }
        var absoluteDeltaY = Math.abs(event.targetTouches[0].clientY - menu.previousY);
        if (absoluteDeltaY > 10 &&
            event.targetTouches[0].clientX <= 280 &&
            menu.currentTranslation > -3) {
            window.isInScrollMode = true;
            return;
        }
        var deltaX = event.targetTouches[0].clientX - menu.previousX;

        if (deltaX !== 0) {
            var translation = deltaX * menu.constanteDeAceleracao;
            var newTrans = translation + menu.currentTranslation;

            if (newTrans > 0) {
                menu.classList.add('rui-sidenav-transition-mode');
                menu.doTranslate(0);
                menu.previousTime = event.timeStamp;
                return;
            }

            if (newTrans < -265) {
                menu.classList.add('rui-sidenav-transition-mode');
                menu.doTranslate(-280);
                return;
            }
            menu.translatePlus(translation);
            menu.previousX = event.targetTouches[0].clientX;
        }
        menu.previousTime = event.timeStamp;

    };

    menuContainer.addEventListener('touchstart', function(event) {
        menu.previousTime = event.timeStamp;
        menu.previousX = event.targetTouches[0].clientX;
        menu.previousY = event.targetTouches[0].clientY;
    }, {
        passive: true
    });

    /* conclui o fechamento */
    menuContainer.addEventListener('touchend', function(event) {
        if (menu.currentTranslation <= -132) {
            $rootScope.menuOpen = false;
        }
        else {
           $rootScope.menuOpen = true;
        }
        window.isInScrollMode = false;
    }, {
        passive: true
    });

    menuContainer.addEventListener('touchmove', touchHandler, {
        passive: true
    });
    menu.classList.remove('nonbounce');
    menu.currentTranslation = 0;

    menu.currentTranslation = -280;
    menu.constanteDeAceleracao = 70;

    menu.openMenu = function() {
        menu.classList.add('rui-sidenav-transition-mode');
        requestAnimationFrame(function() {
            menu.style[transformPropertyName] = 'translate3d(' + 0 + 'px,0,0)';
        });
        overlay.classList.add('active');
        $rootScope.menuOpen = true;
    };

    menu.preventInteraction = function() {
        applicationContentSurface.style.pointerEvents = 'none';
        overlay.style.pointerEvents = 'none';
        setTimeout(function() {
            overlay.style.pointerEvents = 'auto';
            applicationContentSurface.style.pointerEvents = 'auto';
        }, 500);
    };

    menu.closeMenu = function( /*boolean*/ dontPreventInteraction) {
        /* prevent interactions with the content surface and then schedules it's reactivation*/
        if (!dontPreventInteraction) {
            menu.preventInteraction();
        }

        /*do the animations*/
        menu.classList.add('rui-sidenav-transition-mode');
        requestAnimationFrame(function() {
            menu.style[transformPropertyName] = 'translate3d(' + -280 + 'px,0,0)';
        });
        overlay.classList.remove('active');
        $rootScope.menuOpen = false;
    };

    /*
    * @deprecated This function is not necessary anymore, 
    * since the setter method of $rootScope.menuOpen will handle the menu animations by itself.  
    */
    menu.toggle = function() {
        if ($rootScope.menuOpen)
            menu.closeMenu();
        else
            menu.openMenu();
    };

    window.isInScrollMode = false;

    window.toggleRuiSideMenu = menu.toggle;
    window.openRuiSideMenu = menu.openMenu;
    $rootScope.menuOpen = false;
    overlay.addEventListener('click', menu.closeMenu);


    var renderMenuItens = function( /*array: object*/ menu) {

        if (menu.title) {
            var title = document.createElement('span');
            title.className = 'rui-sidenav-title';
            title.textContent = ScreenService.i18n(menu.title);
            itemListContainer.appendChild(title);
        }
        var menuItens = menu.menus;
        for (var i = 0; i < menuItens.length; i++) {
           

            /* create contianer */
            var newListItemContainer = document.createElement('span');
            newListItemContainer.className = 'rui-sidenav-item-container';
            addClickListener(menuItens[i], newListItemContainer);

            /* create label */
            var newListItemText = document.createElement('span');
            newListItemText.className = 'rui-sidenav-item-text';
            newListItemText.textContent = ScreenService.i18n(menuItens[i].label);

            /* create icon */
            var newListItemIcon = document.createElement('i');
            newListItemIcon.className = 'material-icons rui-sidenav-item-icon';
            newListItemIcon.textContent = menuItens[i].icon;

            newListItemContainer.appendChild(newListItemIcon);
            newListItemContainer.appendChild(newListItemText);
            newListItemContainer.menuName = menuItens[i].name;
            if (!menuItens[i].aclIsVisible || !menuItens[i].isVisible)
                newListItemContainer.style.display = 'none';
            itemListContainer.appendChild(newListItemContainer);
            
        }
        var divider = document.createElement('span');
        divider.className = 'rui-sidenav-divider';
        itemListContainer.appendChild(divider);
    };

    /*__menuOpen is a internal property used to control the state of the real property menuOpen */
    $rootScope.__menuOpen = false;
    
    Object.defineProperty($rootScope, 'menuOpen', {

        set: function(newValue) {
            this.__menuOpen = newValue;
            if (newValue) {
                menu.classList.add('rui-sidenav-transition-mode');
                menu.currentTranslation = 0;
                requestAnimationFrame(function() {
                    menu.style[transformPropertyName] = 'translate3d(' + 0 + 'px,0,0)';
                });
                overlay.classList.add('active');
            }
            else {
                menu.preventInteraction();
                menu.classList.add('rui-sidenav-transition-mode');
                menu.currentTranslation = -280;
                requestAnimationFrame(function() {
                    menu.style[transformPropertyName] = 'translate3d(' + -280 + 'px,0,0)';
                });
                overlay.classList.remove('active');
            }
        },
        get: function(newValue) {
            return this.__menuOpen;
        }
    });

}


function initiliazeNewMenuFunction(templateManager, eventAggregator) {
    eventAggregator.subscribe("beforeProjectStartup", function() {
        templateManager.project.setMenuItemVisibility =
            function( /*string*/ menuItemName, /* boolean */ visibility) {
                this.getMenu(menuItemName).isVisible = visibility; /* this === project*/

                /* if menu was already rendered, set the css display property */
                if (typeof itemListContainer !== "undefined") {
                    for (var i = itemListContainer.children.length; i--;) {
                        if (itemListContainer.children[i].menuName === menuItemName) {
                            menuItemToChangeVisibility = itemListContainer.children[i];
                            var newVisibility = (visibility ? 'table' : 'none');
                            menuItemToChangeVisibility.style.display = newVisibility;
                            return;
                        }
                    }
                }
            };
    });
}


Configuration(function(ContextRegister) {
    ContextRegister.register("initiliazeNewMenuFunction", initiliazeNewMenuFunction);
});
