## Zeedhi Customizations Service

zh-customizations-service is a service to handle customizations storage.

You can start following the steps below:

 - Add on your project bower.json file the dependency

  - Example:

```javascript
    "dependencies": {
        "zh-customizations-service": "*"
    }
```
 - Run `bower install`

 - Inject the library on your index.html project file

   - Example:

```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-customizations-service/dist/zhCustomizationsService.js"></script>
<link rel="stylesheet" href="MY_BOWER_COMPONENTS_PATH/zh-customizations-service/dist/style/style.css" />

```
Or the minified version
```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-customizations-service/dist/zhCustomizationsService.min.js"></script>
<link rel="stylesheet" href="MY_BOWER_COMPONENTS_PATH/zh-customizations-service/dist/style/style.css" />

```

 -  **zh-customizations-service** already registers itself as a package. The default `baseUrl` registered is:
```javascript
    window.templateUrls.push(
        {
            package: "zh-customizations-service",
            baseUrl: "bower_components/zh-customizations-service/dist/templates/"
        }
    );
```

So, it considers you have `bower_components` folder in the same path that your `index.html`.

If your `bower_components` is in another folder, you can register your own package path, overwriting the default's one:

```javascript
    window.templateUrls.push(
        {
            package: "zh-customizations-service",
            baseUrl: "MY_BOWER_COMPONENTS_PATH/zh-customizations-service/dist/templates/"
        }
    );
```

Be careful: if you already have a `window.templateUrls` registered, just insert the package's information inside of that. **Do not** override with another instance of `window.templateUrls`
### Configs:
- Configure on your container.json the ZhStorage path and your preferences types.
    - Properties for each preference type :
        - value: string containing the preference type primary key (required)
        - dbName: string containing the database name where the preference will be saved (required)
        - collectionName: string containing the collection name where the preference will be saved (required)
        - label: string containing the label that will appear for the user (required)
        - url: string containing the url where the request will try to catch the preferences json
        - urlFullPath: boolean flag to say that the path is ready to recieve a request
        - customizationsByUser: boolean flag to say that it customization type is by user logged. You should set the user logged primaryKey using "zhCustomizationsService.registerUser('123456789')"
    - Exemple:

```javascript
    "zhStoragePath": "http://storage.zeedhi.com/backend/service/index.php",
    "customizationsRepositories": [
        {
            "value": "1",
            "dbName": "exampleDataBase",
            "collectionName": "global",
            "label": "Global"
        },
        {
            "value": "2",
            "dbName": "exampleDataBase",
            "collectionName": "company",
            "label": "Empresa",
            "url": "http://localhost:8080/teste/preferencia.json",
            "urlFullPath": true
        },
        {
            "value": "4",
            "dbName": "exampleDataBase",
            "collectionName": "user",
            "label": "User",
            "customizationsByUser": true
        }
    ]
```

**Note:** This configurations will be used by each customization module that you are using (zh-layout-preferences, zh-filter-preferences, zh-customization-preferences).