function ServerController(ScreenService, templateManager, Environment, ServerService) {
    this.selectPopUp = function(cadastrarSenha, conferirSenha) {
        var currentPopup = conferirSenha;
        if (!Environment.getLocalVar('password')) {
            currentPopup = cadastrarSenha;
        }
        currentPopup.newRow();
        ScreenService.openPopup(currentPopup);
    };
    this.configureIp = function(configurarIp) {
        popUpConfigurarIp(configurarIp);
    };
    this.validatePass = function(widgetSenha, configurarIp) {
        if (widgetSenha.isValid()) {
            var password = Environment.getLocalVar('password');
            if (password === widgetSenha.currentRow.senha) {
                popUpConfigurarIp(configurarIp);
            } else {
                ScreenService.showMessage(ScreenService.i18n('Senha não confere'), 'error');
            }
        }
    };
    this.setPassword = function(widgetCadastrarSenha, configurarIp) {
        if (widgetCadastrarSenha.isValid()) {
            var row = widgetCadastrarSenha.currentRow;
            if (row.senha.indexOf(" ") >= 0 || row.confirmarsenha.indexOf(" ") >= 0) {
                ScreenService.showMessage(ScreenService.i18n('Senha inválida. Não é permitido "espaço" na senha'), 'error');
            } else if (row.senha !== row.confirmarsenha) {
                ScreenService.showMessage(ScreenService.i18n('Senha não confere'), 'error');
            } else {
                popUpConfigurarIp(configurarIp);
                Environment.setLocalVar('password', row.senha);
                ScreenService.successNotification('Senha cadastrada com sucesso', 3000);
            }
        }
    };

    function popUpConfigurarIp(configurarIp) {
        configurarIp.newRow();
        ScreenService.closePopup();
        ScreenService.openPopup(configurarIp);
        configurarIp.currentRow.ip = getLocalVar('ipSemPorta');
    }
    this.setServerIp = function(widgetConfigurarIp, row, fieldDemonstracao) {
        if (widgetConfigurarIp.isValid()) {
            var ip = row.ip;
            var diretorio = row.diretorio ? '/' + row.diretorio : '';
            var porta = !row.porta ? '' : ':' + row.porta;
            var url = 'https://' + ip + porta + diretorio + window.serviceUrl.replace('..', '');
            templateManager.updateURL(url);
            // do test request
            ServerService.testConnection().then(function(serverStatus) {
                // request success
                Environment.setLocalVar('ipSemPorta', ip);
                Environment.setLocalVar('porta', row.porta);
                Environment.setLocalVar('diretorio', row.diretorio);
                Environment.setLocalVar('ip', url);
                fieldDemonstracao.isVisible = false;
                // close the ip popup
                ScreenService.closePopup();
                templateManager.updateTemplate();
                var conexaoValida = ServerService.compareVersion(serverStatus[0].version);
                var objMessage = ServerService.getObjectMessage(conexaoValida);
                if (conexaoValida === "OK") {
                    ScreenService.successNotification(ScreenService.i18n(objMessage.message), 3000);
                } else {
                    Environment.remove('/connection');
                    ScreenService.showMessage(ScreenService.i18n(objMessage.message), objMessage.type);
                }
            }, function() {
                // request fail
                ScreenService.confirmMessage("Não foi possível conectar ao servidor, deseja manter o IP informado?", 'question', function() {
                    // yes
                    Environment.setLocalVar('ipSemPorta', ip);
                    Environment.setLocalVar('porta', row.porta);
                    Environment.setLocalVar('diretorio', row.diretorio);
                    Environment.setLocalVar('ip', url);
                    fieldDemonstracao.isVisible = false;
                    // close the ip popup
                    ScreenService.closePopup();
                    templateManager.updateTemplate();
                }, function() {
                    // no, set last ip if exists
                    if (Environment.getLocalVar('ip')) {
                        templateManager.updateURL(Environment.getLocalVar('ip'));
                    }
                    widgetConfigurarIp.newRow();
                    templateManager.updateTemplate();
                });
            });
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ServerController', ServerController);
});
