function serviceRequestController(ScreenService, localStorageEngine) {
    this.loadCartFromStorage = function(widget) {
        localStorageEngine.getDataSourceItems("/cartItems").then(function(data) {
            var cartItems = JSON.parse(data);
            if (cartItems && cartItems.length) {
                widget.dataSource.addChangedRows(cartItems);
                widget.reload().then(function() {
                    this.updateCart(widget);
                }.bind(this));
            }
        }.bind(this));
    };
    this.updateCart = function(widget) {
        var cartItems = widget.dataSource.getChangedRows().filter(function(item) {
            return item.QUANTIDADE > 0;
        });
        localStorageEngine.setDataSource("/cartItems", cartItems);
        widget.getHeaderActions("cart").hint = cartItems.length;
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register("ServiceRequestController", serviceRequestController);
});
