var SynchronizeController = function(ScreenService, SynchronizeService, eventAggregator, templateManager) {
    this.sync = function() {
        syncService();
    };
    eventAggregator.subscribe('wscCallUpdate', syncService);

    function syncService() {
        SynchronizeService.sync().then(function(ocurredError) {
            if (!ocurredError) {
                ScreenService.showMessage(ScreenService.i18n('Sincronizado com Sucesso.'), 'success');
            }
            var widget = templateManager.container.getWidget('WidgetMain');
            setTimeout(function() {
                eventAggregator.publish("reloadScreenAndClearFilters", widget);
                menu.closeMenu(); // jshint ignore:line
            }, 600);
        }, function() {
            ScreenService.showMessage(ScreenService.i18n('Não foi possível conectar ao servidor, tente novamente mais tarde.'));
        });
    }
};
Configuration(function(ContextRegister) {
    ContextRegister.register('SynchronizeController', SynchronizeController);
});
