function GeneralMethods(localStorageEngine, ZHPromise, ScreenService) {
    var self = this;
    this.salvaUltimoUsuario = function() {
        if (!localStorageEngine.getLocalVar('DEMO')) {
            localStorageEngine.getDataSource('/User').then(function(user) {
                localStorageEngine.setDataSource('LastUser', user);
                limpaUnidadesUsuario();
            });
        }
    };

    function limpaUnidadesUsuario() {
        var promises = [];
        promises.push(localStorageEngine.remove('/User', []));
        promises.push(localStorageEngine.remove('/Units', []));
        return ZHPromise.all(promises);
    }

    function removeDadosLocaisDoUsuario() {
        var promises = [];
        promises.push(localStorageEngine.setLocalVar('__CDOPERADOR', ""));
        promises.push(localStorageEngine.setLocalVar('__CDFILIAL', ""));
        promises.push(localStorageEngine.setLocalVar('__NRORGTRAB', ""));
        return ZHPromise.all(promises);
    }
    this.verificaNovoUsuario = function(CDOPERADOR, EMAILOPERADOR) {
        ScreenService.hideLoader();
        return localStorageEngine.getDataSource('LastUser').then(function(lastUser) {
            var promises = [];
            if (lastUser[0] && lastUser[0].CDOPERADOR !== CDOPERADOR) {
                ScreenService.confirmMessage("Existem dados de outro usuário no sistema, deseja sobrepor?", 'question', function() {
                    return self.limpaDadosImportados().then(function() {
                        localStorageEngine.setLocalVar('UltimoOperador', EMAILOPERADOR);
                        ScreenService.openWindow('Dashboard');
                    });
                }, function() {
                    promises.push(limpaUnidadesUsuario());
                    promises.push(removeDadosLocaisDoUsuario());
                    return ZHPromise.all(promises);
                });
            } else {
                localStorageEngine.setLocalVar('UltimoOperador', EMAILOPERADOR);
                ScreenService.openWindow('Dashboard');
            }
        });
    };
    this.limpaDadosImportados = function() {
        var promises = [];
        var dataSourceNames = ['/ClientesDoServicoEfetivos', '/DatasCardapioEfetivos', '/DatasEntregaSolicitacao', '/DatasInventario', '/Justificativas', '/Movopsol', '/NovaSolicitacao', '/ProdutosSolicitacao', '/Solicitacao', '/ProximoCodigoSolicitacao', '/Produtos', '/TiposCardapioEfetivos', '/ServicosCardapioEfetivos', '/UltimoInventario', '/ProximoCodigoInventario', '/ProximoCodigoProdutoInventario', '/ProdutosInventario', '/TrocarUnidade', '/ProdutoDatasEntregaSolicitacao', '/ProdutosExcluidos', '/Inventarios', '/ProdutosEditados', 'LastUser', '/Parametros', '/DataFinalInicial', '/InventarioProdutos', '/ServicosEfetivosUnicos', '/CardapioEfetivos'];
        dataSourceNames.forEach(function(name) {
            promises.push(localStorageEngine.remove(name, []));
        });
        localStorageEngine.setLocalVar('ROWNUM', false);
        localStorageEngine.setLocalVar('ROWNUM_INVENT', false);
        localStorageEngine.setLocalVar('ROWNUM_PRODUTO_INVENT', false);
        localStorageEngine.setLocalVar('ROWNUM_LOG', false);
        return ZHPromise.all(promises);
    };
    this.getLang = function() {
        var currentLang = localStorageEngine.getLocalVar('lang');
        var lang;
        if (currentLang === "pt_br") {
            lang = 'BRAZILIAN PORTUGUESE';
        } else if (currentLang === "es_AR") {
            lang = 'SPANISH';
        } else {
            lang = 'BRAZILIAN PORTUGUESE';
        }
        return lang;
    };
    this.converteDataEmObjeto = function(data, spltiString) {
        if (spltiString === '/') {
            return formatoBrasileiroParaObjeto(data);
        } else if (spltiString === '-') {
            return formatoAmericanoParaObjeto(data);
        }
    };

    function formatoBrasileiroParaObjeto(data) {
        var dataSplit = data.split('/');
        var dataObjeto = new Date(dataSplit[2], dataSplit[1] - 1, dataSplit[0]);
        return dataObjeto;
    }

    function formatoAmericanoParaObjeto(data) {
        var dataSplit = data.split('-');
        var dataObjeto = new Date(dataSplit[0], dataSplit[1] - 1, dataSplit[2]);
        return dataObjeto;
    }
    this.retornaDataDeHojeObjeto = function() {
        var date = new Date();
        var dia = date.getDate();
        var mes = date.getMonth();
        var ano = date.getFullYear();
        var hoje = new Date(ano, mes, dia);
        return hoje;
    };
    this.retornaDataHoraDeHojeString = function() {
        var date = new Date();
        var dia = colocaDoisDigitos(date.getDate());
        var mes = colocaDoisDigitos(date.getMonth() + 1);
        var ano = date.getFullYear();
        var hora = colocaDoisDigitos(date.getHours());
        var minutos = colocaDoisDigitos(date.getMinutes());
        var segundos = colocaDoisDigitos(date.getSeconds());
        return ano + "-" + mes + "-" + dia + " " + hora + ":" + minutos + ":" + segundos;
    };
    this.retornaDataDeHojeString = function() {
        var date = new Date();
        var dia = colocaDoisDigitos(date.getDate());
        var mes = colocaDoisDigitos(date.getMonth() + 1);
        var ano = date.getFullYear();
        return dia + "/" + mes + "/" + ano;
    };

    function colocaDoisDigitos(value) {
        if (value < 10) {
            value = '0' + value;
        }
        return value;
    }
    this.valorCorreto = function(value) {
        var index = value.toString().indexOf(',');
        var valueFloat = parseFloat(value);
        /* global Util*/
        if (valueFloat <= 0 || Util.isEmptyOrBlank(value) || isNaN(valueFloat) || index !== -1) {
            return false;
        }
        return true;
    };
    this.valorCorretoMaiorIgualZero = function(value) {
        var index = value.toString().indexOf(',');
        var valueFloat = parseFloat(value);
        if (valueFloat < 0 || Util.isEmptyOrBlank(value) || isNaN(valueFloat) || index !== -1) {
            return false;
        }
        return true;
    };
    this.criarLogMovopsol = function(currentRow, IDOPERAMOVS, QTANTOPER, QTDEPOPER) {
        var ROWNUM = localStorageEngine.getLocalVar('ROWNUM_LOG');
        if (!ROWNUM) {
            ROWNUM = 'L1';
        } else {
            var split = ROWNUM.split('L');
            split[1]++;
            var novaROWNUM = split[1];
            ROWNUM = 'L' + novaROWNUM;
        }
        var objetoMovopsol = {
            ROWNUM: ROWNUM,
            CDFILSOLMOV: currentRow.CDFILSOLI,
            CDFILLANMOV: currentRow.CDFILLAN,
            NRSOLIMOV: currentRow.NRSOLICMP,
            CDPRODUTO: currentRow.CDPRODUTO,
            DTPROGENTR: currentRow.DTPROGENTR,
            DTOPERSOL: this.retornaDataHoraDeHojeString(),
            CDOPERADOR: localStorageEngine.getLocalVar('__CDOPERADOR'),
            DSJUSTOPER: currentRow.DSJUSTOPER || null,
            QTANTOPER: QTANTOPER,
            QTDEPOPER: QTDEPOPER,
            NRORG: currentRow.NRORG,
            IDOPERAMOVS: IDOPERAMOVS,
            changed: true
        };
        localStorageEngine.setLocalVar('ROWNUM_LOG', ROWNUM);
        return localStorageEngine.getDataSource('/Movopsol').then(function(movopsol) {
            if (!movopsol) {
                movopsol = [];
            }
            movopsol.push(objetoMovopsol);
            return localStorageEngine.setDataSource('/Movopsol', movopsol);
        });
    };
    this.concatenaDataComDiaDaSemana = function(data) {
        var dataSplit = data.split('/');
        var date = new Date(dataSplit[2], dataSplit[1] - 1, dataSplit[0]);
        var diaDaSemana = date.getDay();
        if (diaDaSemana === 0) {
            data = data + ' - ' + 'DOMINGO';
        } else if (diaDaSemana === 1) {
            data = data + ' - ' + 'SEGUNDA-FEIRA';
        } else if (diaDaSemana === 2) {
            data = data + ' - ' + 'TERÇA-FEIRA';
        } else if (diaDaSemana === 3) {
            data = data + ' - ' + 'QUARTA-FEIRA';
        } else if (diaDaSemana === 4) {
            data = data + ' - ' + 'QUINTA-FEIRA';
        } else if (diaDaSemana === 5) {
            data = data + ' - ' + 'SEXTA-FEIRA';
        } else if (diaDaSemana === 6) {
            data = data + ' - ' + 'SÁBADO';
        }
        return data;
    };
    this.lastTwoWeeks = function(format) {
        return {
            start: moment().subtract(15, 'days').format(format),
            end: moment().format(format),
            value: "1"
        };
    };
    this.nextTwoWeeks = function(format) {
        return {
            start: moment().format(format),
            end: moment().add(15, 'days').format(format),
            value: "2"
        };
    };
    this.lastThirtyDays = function(format) {
        return {
            start: moment().subtract(30, 'days').format(format),
            end: moment().format(format),
            value: "3"
        };
    };
    this.nextThirtyDays = function(format) {
        return {
            start: moment().format(format),
            end: moment().add(30, 'days').format(format),
            value: "4"
        };
    };
    this.focus = function(selector) {
        setTimeout(function() {
            var elem = document.querySelector(selector);
            if (elem) {
                elem.focus();
                elem.click();
            }
        }, 300);
    };
    this.onlyIntergerNumbers = function(selector) {
        setTimeout(function() {
            var elem = $(selector);
            elem.keypress(function(e) {
                var intergerNumbers = [48, 49, 50, 51, 52, 53, 54, 55, 56, 57];
                var numberCode = e.which;
                if (intergerNumbers.indexOf(numberCode) < 0) {
                    e.preventDefault();
                }
            });
            onpaste(elem, 0);
        }, 300);
    };
    this.onlyFloatNumbers = function(selector) {
        setTimeout(function() {
            var elem = $(selector);
            elem.keypress(function(e) {
                var intergerNumbers = [46, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57];
                var numberCode = e.which;
                if ((intergerNumbers.indexOf(numberCode) < 0) || (numberCode === 46 && e.currentTarget.value.indexOf(String.fromCharCode(numberCode)) >= 0)) {
                    e.preventDefault();
                }
            });
            onpaste(elem, 0);
        }, 300);
    };
    var onpaste = function(elem, i) {
        if (elem.hasOwnProperty(i)) {
            elem[i].onpaste = function(e) {
                e.preventDefault();
            };
            i++;
            onpaste(i);
        }
    };
    this.onBack = function() {
        if (ScreenService.isPopupOpen()) {
            var popup = ScreenService.getPopupOpen();
            if (popup.getActionsByVisibility('back') && popup.getActionsByVisibility('back').length) {
                popup.getActionsByVisibility('back')[0].click();
            } else {
                ScreenService.closePopup();
            }
        } else if (ScreenService.isWidgetEditing()) {
            ScreenService.stopEditWidget();
        } else if (ScreenService.isSideMenuOpen()) {
            ScreenService.toggleSideMenu();
        } else if (ScreenService.isAlertShown()) {
            // close alert only if there is just the ok button
            var alertContainer = $('.zh-container-alert').parent();
            if (alertContainer.find('.zh-alert-button-ok').length === 1) {
                alertContainer.hide();
            }
        } else if ($(':focus').is('.inline-edit')) {
            // inline editable grid -> navigate
            $(':focus').blur();
        } else if ($('.zh-footer-left .previous:visible').length > 0) {
            // click on the back button if it is visible
            $('.zh-footer-left .previous:visible').click();
        } else {
            ScreenService.goBack();
        }
    };
    this.updateItemsPerPage = function(widget) {
        if (Util.isPhone() || Util.isTablet() || Util.isMobile()) {
            widget.itemsPerPage = 15;
        } else if (Util.isDesktop()) {
            widget.itemsPerPage = 40;
        }
    };
    this.gerarProdutoFiltroSolicitacao = function(produtosSolicitacao) {
        var produtos = [];
        for (var i = 0; i < produtosSolicitacao.length; i++) {
            var produto = {
                CDFILSOLI: produtosSolicitacao[i].CDFILSOLI,
                CDPRODUTO: produtosSolicitacao[i].CDPRODUTO,
                NMPRODUTO: produtosSolicitacao[i].NMPRODUTO
            };
            produtos.push(produto);
        }
        var produtosUnicos = removerProdutosRedundantes(produtos);
        return localStorageEngine.setDataSource("/ProdutoDatasEntregaSolicitacao", produtosUnicos);
    };

    function removerProdutosRedundantes(produtos) {
        var produtosunicos = [];
        var valor = '';
        var pesquisaItem = function(pesquisa, arrayPesquisar) {
            for (var fkey = 0; fkey < arrayPesquisar.length; fkey++) {
                if (arrayPesquisar[fkey].CDPRODUTO === pesquisa.CDPRODUTO && arrayPesquisar[fkey].CDFILSOLI === pesquisa.CDFILSOLI) {
                    return true;
                }
            }
            return false;
        };
        for (var key = 0; key < produtos.length; key++) {
            valor = produtos[key];
            if (false === pesquisaItem(valor, produtosunicos)) {
                produtosunicos.push(valor);
            }
        }
        return produtosunicos;
    }
    this.setDefaultTab = function(widget) {
        widget.parent.defaultTab = widget.name;
    };
    this.updateActionsAndFields = function(grid, formEdit) {
        var dataset = grid.dataSource.data;
        var currentRow = grid.currentRow;
        var actionNext = formEdit.getAction('next');
        var actionBack = formEdit.getAction('back');
        var fieldSaveAndNext = formEdit.getField('saveAndNext');
        var fieldSaveAndBack = formEdit.getField('saveAndBack');
        var elementSaveAndNext = $('#saveAndNext');
        var elementSaveAndBack = $('#saveAndBack');
        if (dataset.length === 1) {
            actionNext.readOnly = true;
            actionBack.readOnly = true;
            fieldSaveAndNext.readOnly = true;
            fieldSaveAndBack.readOnly = true;
            addClass('#saveAndNext', 'save-and-next-last-item');
            addClass('#saveAndBack', 'save-and-next-last-item');
        } else if ((dataset.length - 1) === dataset.indexOf(currentRow)) {
            actionNext.readOnly = true;
            actionBack.readOnly = false;
            fieldSaveAndNext.readOnly = true;
            fieldSaveAndBack.readOnly = false;
            addClass('#saveAndNext', 'save-and-next-last-item');
            elementSaveAndBack.removeClass('save-and-next-last-item');
        } else if (dataset.indexOf(currentRow) === 0) {
            actionNext.readOnly = false;
            actionBack.readOnly = true;
            fieldSaveAndNext.readOnly = false;
            fieldSaveAndBack.readOnly = true;
            elementSaveAndNext.removeClass('save-and-next-last-item');
            addClass('#saveAndBack', 'save-and-next-last-item');
        } else {
            actionNext.readOnly = false;
            actionBack.readOnly = false;
            fieldSaveAndNext.readOnly = false;
            fieldSaveAndBack.readOnly = false;
            elementSaveAndNext.removeClass('save-and-next-last-item');
            elementSaveAndBack.removeClass('save-and-next-last-item');
        }
    };

    function addClass(elem, cssClass) {
        var elementSaveAndNext = $(elem);
        if (elementSaveAndNext[0]) {
            elementSaveAndNext.addClass(cssClass);
        } else {
            setTimeout(function() {
                elementSaveAndNext = $(elem);
                elementSaveAndNext.addClass(cssClass);
            }, 300);
        }
    }
    this.sortArray = function() {
        var array = arguments[0];
        var orderByColumns = arguments[1];
        var orderByTypes = arguments[2] || [];
        array.sort(function(obj, nextObj) {
            var index = 0;
            return compare(obj, nextObj, orderByColumns, index, orderByTypes);
        });
        return array;
    };
    var orderTypes = {
        "ASC": 1,
        "DESC": -1,
        "SAME": 0
    };
    var compare = function(obj, nextObj, orderByColumns, index, orderByTypes) {
        if (obj[orderByColumns[index]] === nextObj[orderByColumns[index]]) {
            index++;
            if (orderByColumns.hasOwnProperty(index)) {
                return compare(obj, nextObj, orderByColumns, index, orderByTypes);
            } else {
                return orderTypes.SAME;
            }
        } else if (obj[orderByColumns[index]] > nextObj[orderByColumns[index]]) {
            if (orderByTypes.hasOwnProperty(index) && orderTypes.hasOwnProperty(orderByTypes[index])) {
                return orderTypes[orderByTypes[index]];
            } else {
                return orderTypes.ASC;
            }
        } else if (obj[orderByColumns[index]] < nextObj[orderByColumns[index]]) {
            if (orderByTypes.hasOwnProperty(index) && orderTypes.hasOwnProperty(orderByTypes[index])) {
                return orderTypes[orderByTypes[index]] * -1;
            } else {
                return orderTypes.DESC;
            }
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('GeneralMethods', GeneralMethods);
});
