var AppointmentService = function(localStorageEngine, AppointmentRepository, Environment, BioEvaluationRepository, ZHPromise, restEngine, ScreenService, metaDataFactory) {
    // EVALUATION DATA
    this.setEvaluationDataMethods = function(methods) {
        localStorageEngine.setLocalVar('__evaluationDataMethods', methods);
    };
    this.addFields = function() {
        return localStorageEngine.getLocalVar('__evaluationDataMethods');
    };
    this.save = function(row) {
        return AppointmentRepository.save(row);
    };
    this.bioEvaluationSave = function(row) {
        return BioEvaluationRepository.save(row);
    };
    this.anthDataEvaluation = function(widget) {
        if (widget.dataSource.checkedRows.length > 0) {
            var fields = [];
            var promise = [];
            promise = widget.dataSource.checkedRows.map(function(checkedRow) {
                var methodsFilter = [];
                if (checkedRow.method === undefined) {
                    methodsFilter = [{
                        "name": "methodEvaluationId",
                        "operator": "=",
                        "value": checkedRow.methodEvaluationId
                    }];
                } else {
                    methodsFilter = [{
                        "name": "methodEvaluationId",
                        "operator": "=",
                        "value": checkedRow.method
                    }];
                }
                return localStorageEngine.getDataSource('/DataEvaluations', methodsFilter).then(function(dataEvaluations) {
                    dataEvaluations.forEach(function(field) {
                        fields.push({
                            id: field.dataEvaluationId,
                            method: field.methodEvaluationId
                        });
                    });
                });
            });
            var _initValue = function(field) {
                var dataInfoFilter = [{
                    "name": "id",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar('__patient')
                }, {
                    "name": "appointmentDate",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar('__appointment')
                }, {
                    "name": "dataTypeEvaluationId",
                    "operator": "=",
                    "value": field.id
                }, {
                    "name": "methodEvaluationId",
                    "operator": "=",
                    "value": field.method
                }];
                return localStorageEngine.getDataSource('/DataInfoEvaluations', dataInfoFilter).then(function(dataInfoEvaluations) {
                    if (dataInfoEvaluations.length > 0) {
                        field.value = dataInfoEvaluations[0].value;
                    } else {
                        field.value = null;
                    }
                });
            };
            var _initName = function(field) {
                var typeFilter = [{
                    "name": "dataTypeEvaluationId",
                    "operator": "=",
                    "value": field.id
                }];
                return localStorageEngine.getDataSource('/DataTypeEvaluations', typeFilter).then(function(dataTypeEvaluations) {
                    field.name = dataTypeEvaluations[0].dataTypeEvaluationName;
                });
            };
            var addField = function() {
                var aux = [];
                var obj = {
                    "isVisible": true,
                    "showOnView": true,
                    "template": "field/text-edit.html",
                    "validations": {
                        "required": true
                    }
                };
                fields.map(function(field) {
                    _initValue(field).then(function() {
                        _initName(field).then(function() {
                            if (aux.indexOf(field.id) === -1) {
                                obj.isVisible = true;
                                aux.push(field.id);
                            } else {
                                obj.isVisible = false;
                            }
                            obj.id = field.method;
                            obj.name = field.id;
                            obj.label = field.name;
                            obj.defaultValue = field.value;
                            metaDataFactory.fieldFactory(obj, widget.widgets[0].widgets[0], true);
                            widget.widgets[0].widgets[0].getField(obj.name).defaultValue = field.value;
                            widget.widgets[0].widgets[0].getField(obj.name).value = field.value;
                            widget.widgets[0].widgets[0].getField(obj.name).applyDefaultValue();
                        });
                    });
                });
                ScreenService.openSwipe(widget.widgets[0]);
            };
            return ZHPromise.all(promise).then(function() {
                return addField();
            });
        }
    };
    this.anthCalculate = function(widget) {
        var antevalselectedRows = widget.selectedRows;
        var antrAvaliationPopup = widget.container.getWidget('antrAvaliationPopup');
        var fields = [];
        var appointmentDateFix = localStorageEngine.getLocalVar('__normalizedAppointment');
        if (antrAvaliationPopup.isValid()) {
            antevalselectedRows.forEach(function(selecteds) {
                widget.localDataSourceLoaded.DataEvaluations.forEach(function(todos) {
                    if (selecteds.methodEvaluationId === todos.methodEvaluationId) {
                        fields.push({
                            id: todos.dataEvaluationId,
                            method: selecteds.methodEvaluationId,
                            value: antrAvaliationPopup.currentRow[todos.dataEvaluationId]
                        });
                    }
                });
            });
            var filtro = [{
                "name": "date",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__normalizedAppointment')
            }, {
                "name": "id",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__patient')
            }, {
                "name": "unit",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__CDFILIAL')
            }];
            localStorageEngine.getDataSource('/Appointments', filtro).then(function(appointments) {
                appointments[0].changed = true;
                if (antrAvaliationPopup.currentRow['01']) {
                    appointments[0].weight = antrAvaliationPopup.currentRow['01'];
                }
                if (antrAvaliationPopup.currentRow['02']) {
                    appointments[0].height = antrAvaliationPopup.currentRow['02'];
                }
                localStorageEngine.save('/Appointments', appointments).then(function() {
                    widget.curPatient.Appointments.forEach(function(aux) {
                        if (aux.normalizedDate === appointments[0].date) {
                            aux.changed = true;
                            if (antrAvaliationPopup.currentRow['01']) {
                                aux.weight = antrAvaliationPopup.currentRow['01'];
                            }
                            if (antrAvaliationPopup.currentRow['02']) {
                                aux.height = antrAvaliationPopup.currentRow['02'];
                            }
                        }
                    });
                });
            });
            var promises = [];
            var toSave = [];
            fields.forEach(function(field) {
                var filter = [{
                    "name": "id",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar('__patient')
                }, {
                    "name": "appointmentDate",
                    "operator": "=",
                    "value": appointmentDateFix
                }, {
                    "name": "dataTypeEvaluationId",
                    "operator": "=",
                    "value": field.id
                }, {
                    "name": "methodEvaluationId",
                    "operator": "=",
                    "value": field.method
                }];
                promises.push(localStorageEngine.getDataSource('/DataInfoEvaluations', filter).then(function(dataInfoEvaluations) {
                    var now = new Date();
                    var key = now.getTime();
                    if (dataInfoEvaluations.length > 0) {
                        if (dataInfoEvaluations[0].value !== field.value) {
                            dataInfoEvaluations[0].changed = true;
                            dataInfoEvaluations[0].value = field.value;
                            dataInfoEvaluations[0].__is_new = true;
                            dataInfoEvaluations[0].key = key;
                            toSave.push(dataInfoEvaluations[0]);
                        }
                    } else {
                        if (field.value !== null) {
                            dataInfoEvaluations.push({
                                __is_new: true,
                                changed: true,
                                id: localStorageEngine.getLocalVar('__patient'),
                                appointmentDate: appointmentDateFix,
                                dataTypeEvaluationId: field.id,
                                key: key,
                                methodEvaluationId: field.method,
                                unit: localStorageEngine.getLocalVar('__CDFILIAL'),
                                value: field.value
                            });
                            toSave.push(dataInfoEvaluations[0]);
                        }
                    }
                }));
            });
            return ZHPromise.all(promises).then(function() {
                return localStorageEngine.saveInServer('/Appointments').then(function() {
                    return localStorageEngine.save('/DataInfoEvaluations', toSave).then(function() {
                        return localStorageEngine.saveInServer('/AnthEvaluationMethods').then(function() {
                            return restEngine.post('/DataInfoEvaluations/save', {
                                "requestType": "DataSet",
                                "dataset": toSave
                            }).then(function() {
                                var ids = "";
                                for (var i = 0; i < fields.length; i++) {
                                    if (ids.search(fields[i].method) === -1) {
                                        ids = ids.concat("_", fields[i].method);
                                    }
                                }
                                ids += "_";
                                var patient = widget.curPatient;
                                restEngine.post('/AnthEvaluationResult', {
                                    "requestType": "Row",
                                    "row": {
                                        "id": patient.id,
                                        "unit": patient.unit,
                                        "age": patient.age,
                                        "yearAndMonth": patient.yearAndMonth,
                                        "appointmentDate": appointmentDateFix,
                                        "avaliations": ids
                                    }
                                }, function(success) {
                                    var deferred = ZHPromise.defer();
                                    if (success.dataset.error) {
                                        ScreenService.showMessage(ScreenService.i18n(success.dataset.error.GENERIC_MESSAGE));
                                        deferred.reject();
                                        return deferred;
                                    } else {
                                        deferred.resolve();
                                        return restEngine.post('/Structures', {
                                            "requestType": "Row",
                                            "row": {
                                                "unitID": localStorageEngine.getLocalVar('__CDFILIAL'),
                                                "nutritionistID": localStorageEngine.getLocalVar('__CDOPERADOR')
                                            }
                                        }, function() {
                                            antrAvaliationPopup.resultadoAuth = success.dataset.Result;
                                        }, undefined, function(error) {
                                            console.log(error);
                                        });
                                    }
                                }, undefined, function(error) {
                                    console.log(error);
                                });
                            });
                        });
                    });
                });
            });
        }
    };
    this.saveCheckedRows = function(checkedRows) {
        var rows = [];
        checkedRows.map(function(checkedRow) {
            if (checkedRow.__isSelected === undefined) {
                checkedRow.__isSelected = false;
            }
            checkedRow.changed = true;
            checkedRow.id = localStorageEngine.getLocalVar('__patient');
            checkedRow.unit = localStorageEngine.getLocalVar('__CDFILIAL');
            checkedRow.__is_new = true;
            checkedRow.appointmentDate = checkedRow.date;
            rows.push(checkedRow);
        });
        var count = 0;
        var save = function() {
            if (count < rows.length) {
                return localStorageEngine.save('/AnthEvaluationMethods', rows).then(function() {
                    count++;
                    return save();
                });
            }
        };
        return ZHPromise.all(rows).then(function() {
            return save();
        });
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register('AppointmentService', AppointmentService);
});
