function ServerService(Query, ServerRepository, Environment) {
    var FRONT_END_VERSION = '1.0';
    var messages = {
        OK: {
            message: "Conexão realizada com sucesso!",
            type: "information"
        },
        NEW_VERSION: {
            message: "Existe uma nova versão disponível da aplicação. Acesse a loja e atualize!",
            type: "information"
        },
        SERVER_OUT: {
            message: "Servidor desatualizado. Favor entrar em contato com o administrador.",
            type: "error"
        }
    };
    this.testConnection = function() {
        var query = Query.build();
        return ServerRepository.download(query);
    };
    this.verifieVersionStatus = function() {
        return Environment.getDataSource('/connection', [], null, 999999).then(function(connection) {
            if (connection.length !== 0) {
                return this.compareVersion(connection[0].version);
            } else {
                return this.testConnection().then(function(connection) {
                    return this.compareVersion(connection[0].version);
                }.bind(this));
            }
        }.bind(this));
    };
    this.compareVersion = function(version) {
        var status = "OK";
        if (parseFloat(version) > parseFloat(FRONT_END_VERSION)) {
            status = "NEW_VERSION";
        } else if (parseFloat(version) < parseFloat(FRONT_END_VERSION)) {
            status = "SERVER_OUT";
        }
        return status;
    };
    this.getObjectMessage = function(messageId) {
        return messages[messageId];
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ServerService', ServerService);
});
