var Environment = function(templateManager, localStorageEngine, ScreenService, ZHPromise, dataSourceHolder, GeneralMethods) {
    var storey;
    var hall;
    var bed;
    var currentPatient;
    var dataSourceMain;
    var currentPrescription;
    var prescriptionDataSource;
    var currentAppointment;
    var appointmentDataSource;
    this.windowReload = function(container) {
        container.eachWidget(function(widget) {
            widget.reload().then(function() {
                templateManager.updateTemplate();
            });
        });
    };
    this.ZHAll = function(promises) {
        return ZHPromise.all(promises);
    };
    // CURRENT PATIENT
    this.setCurrentPatientId = function(id) {
        localStorageEngine.setLocalVar('__patient', id);
    };
    this.getCurrentPatientId = function() {
        return localStorageEngine.getLocalVar('__patient');
    };
    this.getCurrentPatient = function() {
        return currentPatient;
    };
    this.setCurrentPatient = function(patient) {
        currentPatient = patient;
        localStorageEngine.setLocalVar('__hospitalization', patient.hospitalization);
    };
    this.getDataSource = function(name, filtro, page, itemsPerPage) {
        return localStorageEngine.getDataSource(name, filtro, page, itemsPerPage);
    };
    this.getDataSourceMain = function() {
        return dataSourceMain;
    };
    this.setDataSourceMain = function(dataSource) {
        dataSourceMain = dataSource;
    };
    // CURRENT PRESCRIPTION
    this.setCurrentPrescriptionDate = function(date) {
        localStorageEngine.setLocalVar('__prescription', date);
    };
    this.getCurrentPrescription = function() {
        return currentPrescription;
    };
    this.setCurrentPrescription = function(patient) {
        currentPrescription = patient;
    };
    this.getPrescriptionDataSource = function() {
        return prescriptionDataSource;
    };
    this.setPrescriptionDataSource = function(dataSource) {
        prescriptionDataSource = dataSource;
    };
    // CURRENT CONSULTATION
    this.setCurrentAppointmentDate = function(date) {
        localStorageEngine.setLocalVar('__appointment', date);
    };
    this.getCurrentAppointmentDate = function() {
        return localStorageEngine.getLocalVar('__appointment');
    };
    this.getCurrentAppointment = function() {
        return currentAppointment;
    };
    this.setCurrentAppointment = function(patient) {
        currentAppointment = patient;
    };
    this.getAppointmentDataSource = function() {
        return appointmentDataSource;
    };
    this.setAppointmentDataSource = function(dataSource) {
        appointmentDataSource = dataSource;
    };
    // ANTHROPOMETRIC EVALUATION
    this.setEvaluationMethods = function(methods) {
        localStorageEngine.setLocalVar('__evaluationMethods', methods);
    };
    this.getEvaluationMethods = function() {
        return localStorageEngine.getLocalVar('__evaluationMethods');
    };
    this.getLocalVar = function(name) {
        return localStorageEngine.getLocalVar(name);
    };
    this.setLocalVar = function(name, value) {
        localStorageEngine.setLocalVar(name, value);
    };
    this.remove = function(name, value) {
        if (!value) {
            value = [];
        }
        return localStorageEngine.remove(name, value);
    };
    // this.getDataSource = function(name) {
    //     return localStorageEngine.getDataSource(name);
    // };
    this.setLabelToStripe = function(widget) {
        if (widget.name === 'WidgetMain') {
            widget.__filterPopup.fields.forEach(function(field) {
                if (field.name === 'unit') {
                    field.label = ScreenService.i18n("Unidade") + ": " + localStorageEngine.getLocalVar('__CDFILIAL');
                }
                if (field.name === 'storey') {
                    if (field.value()) {
                        templateManager.container.getWidget('WidgetStripe').getField("storey").label = ScreenService.i18n("Andar") + ": " + field.value();
                    } else {
                        templateManager.container.getWidget('WidgetStripe').getField("storey").label = ScreenService.i18n("Andar") + ": " + ScreenService.i18n("Todos");
                    }
                }
                if (field.name === 'hall') {
                    if (field.value()) {
                        templateManager.container.getWidget('WidgetStripe').getField("hall").label = ScreenService.i18n("Ala") + ": " + field.value();
                    } else {
                        templateManager.container.getWidget('WidgetStripe').getField("hall").label = ScreenService.i18n("Ala") + ": " + ScreenService.i18n("Todos");
                    }
                }
                if (field.name === 'bed') {
                    if (field.value()) {
                        templateManager.container.getWidget('WidgetStripe').getField("bed").label = ScreenService.i18n("Leito") + ": " + field.value();
                    } else {
                        templateManager.container.getWidget('WidgetStripe').getField("bed").label = ScreenService.i18n("Leito") + ": " + ScreenService.i18n("Todos");
                    }
                }
                field.reload();
            });
        } else {
            widget.fields.forEach(function(field) {
                if (field.name === 'unit') {
                    field.label = ScreenService.i18n("Unidade") + ": " + localStorageEngine.getLocalVar('__CDFILIAL');
                }
                if (field.name === 'storey') {
                    if (storey) {
                        field.label = ScreenService.i18n("Andar") + ": " + storey;
                    } else {
                        field.label = ScreenService.i18n("Andar") + ": " + ScreenService.i18n("Todos");
                    }
                }
                if (field.name === 'hall') {
                    if (hall) {
                        field.label = ScreenService.i18n("Ala") + ": " + hall;
                    } else {
                        field.label = ScreenService.i18n("Ala") + ": " + ScreenService.i18n("Todos");
                    }
                }
                if (field.name === 'bed') {
                    if (bed) {
                        field.label = ScreenService.i18n("Leito") + ": " + bed;
                    } else {
                        field.label = ScreenService.i18n("Leito") + ": " + ScreenService.i18n("Todos");
                    }
                }
                field.reload();
            });
        }
    };
    this.initStructureParams = function() {
        storey = localStorageEngine.getLocalVar('__storey');
        hall = localStorageEngine.getLocalVar('__hall');
        bed = localStorageEngine.getLocalVar('__bed');
    };
    this.setStructureParams = function(fields) {
        localStorageEngine.setLocalVar('__storey', fields.storey);
        localStorageEngine.setLocalVar('__hall', fields.hall);
        localStorageEngine.setLocalVar('__bed', fields.bed);
    };
    var _prepareFilter = function(filterName, filterValue) {
        return {
            name: filterName,
            operator: '=',
            value: filterValue
        };
    };
    this.setDataSourceFilter = function(widget) {
        widget.dataSourceFilter = [];
        if (storey) {
            widget.dataSourceFilter.push(_prepareFilter('storey', storey));
        }
        if (hall) {
            widget.dataSourceFilter.push(_prepareFilter('hall', hall));
        }
        if (bed) {
            widget.dataSourceFilter.push(_prepareFilter('bed', bed));
        }
        widget.dataSourceFilter.push({
            name: 'situation',
            operator: '=',
            value: 'INTERNADO'
        }, {
            name: 'unit',
            operator: '=',
            value: localStorageEngine.getLocalVar('__CDFILIAL')
        });
        widget.reload().then(function() {
            templateManager.updateTemplate();
        });
    };
    this.afterLogin = function() {
        ScreenService.openWindow('MapNutritionist');
    };
    this.lastPatientVisit = function() {
        var filter = [{
            'name': 'id',
            'operator': '=',
            'value': localStorageEngine.getLocalVar('__patient')
        }, {
            'name': 'unit',
            'operator': '=',
            'value': localStorageEngine.getLocalVar('__CDFILIAL')
        }];
        localStorageEngine.getDataSource('/Patients', filter).then(function(patient) {
            patient[0].lastVisit = moment().format("DD/MM/YYYY HH:MM:ss");
            localStorageEngine.save('/Patients', patient[0]);
        });
    };
    var ALL_RECORDS = 999999999;
    this.setDataSource = function(name, value) {
        return localStorageEngine.setDataSource(name, value);
    };
    this.save = function(name, object) {
        return this.getDataSource(name, [], null, ALL_RECORDS).then(function(dataset) {
            var clearedName = dataSourceHolder.clearName(name);
            var dataToSave = angular.isArray(object) ? object : [object];
            var willBeSaved = false;
            for (var i = 0; i < dataToSave.length; i++) {
                var newData = dataToSave[i];
                for (var index = 0; index < dataset.length; index++) {
                    var row = dataset[index];
                    if (equalByLocalKey(row, newData, clearedName)) {
                        dataset[index] = newData;
                        willBeSaved = true;
                    }
                }
                if (!willBeSaved) {
                    dataset.push(newData);
                }
            }
            dataset = orderByLocalOrder(name, dataset);
            return this.setDataSource(name, dataset);
        }.bind(this));
    };
    var equalByLocalKey = function(row, object, name) {
        var dataSource = getDataSourceByName(name);
        return dataSource.localKey.every(function(localKey) {
            return row[localKey] === object[localKey];
        });
    };
    var orderByLocalOrder = function(name, dataset) {
        var dataSource = getDataSourceByName(name);
        if (dataSource.localOrder) {
            return GeneralMethods.sortArray(dataset, dataSource.localOrder);
        } else {
            return dataset;
        }
    };
    var getDataSourceByName = function(name) {
        name = dataSourceHolder.clearName(name);
        var dataSources = dataSourceHolder.dataSources;
        if (!dataSources[name]) {
            throw 'dataSource ' + name + 'not found';
        }
        return dataSources[name][name];
    };
    this.saveInServer = function(name, callback, dataSource, retryCount, timeout) {
        return localStorageEngine.saveInServer(name, callback, dataSource, retryCount, timeout);
    };
    this.defer = function() {
        return ZHPromise.defer();
    };
    this.showLoader = function() {
        $rootScope.$broadcast("request.start");
    };
    this.hideLoader = function() {
        $rootScope.$broadcast("request.stop");
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register('Environment', Environment);
});
