function messages(restEngine) {
    var messages = {};
    /**
     * Global method to get a message by its code
     * @param  {String} code - Code of message
     * @return {String} Message corresponding to the code
     */
    this.getMessage = function(code) {
        if (!messages.hasOwnProperty(code)) {
            return messages.messageNotFound;
        }
        return messages[code];
    };
    /**
     * Get messages file
     * @return {Object} Messages object
     */
    function requestMessagesFile() {
        var messagesPath = "json/messages.json";
        return restEngine.requestMetaData(messagesPath).then(function(response) {
            return response.data;
        });
    }
    /**
     * Set messages object in global messages variable
     * @param {Object} requestedMessages - Messages object
     */
    function setMessages(requestedMessages) {
        messages = requestedMessages;
    }
    /**
     * Create default messages object if the messages file was not found
     */
    function messagesFileNotFound() {
        messages = {
            "messageNotFound": "Message not found"
        };
    }
    window.getMessage = this.getMessage;
    requestMessagesFile().then(setMessages).catch(messagesFileNotFound);
}
/*global Configuration*/
Configuration(function(ContextRegister) {
    ContextRegister.register('Messages', messages);
});
